%define major     16
%define libname   %mklibname yui %{major}
%define develname %mklibname yui -d

#--------------------------------------------------------
# Package libyui-ncurses
%define yui_ncurses_name libyui-ncurses

%define libncurses %mklibname yui-ncurses %{major}
%define devncurses %mklibname yui-ncurses -d
#--------------------------------------------------------
# Package libyui-qt
%define yui_qt_name libyui-qt

%define libqt %mklibname yui-qt %{major}
%define devqt %mklibname yui-qt -d
#--------------------------------------------------------

# bootstrap build with/without libyui-mga
# without = with libyui-mga
# with = without libyui-mga
%bcond_without mga

Name:           libyui
Version:        4.4.4
Release:        %mkrel 11
Summary:        YaST2 User Interface Engine
Group:          System/Libraries
License:        LGPLv2+
URL:            https://github.com/libyui/libyui
Source0:        https://github.com/libyui/libyui/archive/%{version}/%{name}-%{version}.tar.bz2
Patch0:         libyui-cmake-4.0.patch

BuildRequires:  cmake
BuildRequires:  boost-devel
BuildRequires:  libtool
BuildRequires:  perl-devel
BuildRequires:  pkgconfig(ruby)
BuildRequires:  ruby-RubyGems
BuildRequires:  swig
BuildRequires:  pkgconfig(python3)

BuildRequires:  pkgconfig(libpng)
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5Gui)
BuildRequires:  pkgconfig(Qt5Svg)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5X11Extras)

BuildRequires: pkgconfig(ncursesw)
BuildRequires: pkgconfig(ncurses)

%if %{with mga}
BuildRequires:  pkgconfig(libyui-mga)
%endif

%description
libYUI is a library written entirely in C++ to provide an abstraction layer for
Qt, GTK and ncurses UI frameworks. This means that a single code in YUI can be
used to produce outputs using any of the 3 UI frameworks listed above. This
library was (and still is) used to create the YaST2 User Interface.

#----------------------------------------------------------
# libyui

%package -n %libname
Summary:      YaST2 User Interface Engine
Group:        System/Libraries
Provides:     %{name} = %{version}-%{release}
Provides:     %{name}%{?_isa} = %{version}-%{release}
Provides:     %{name}%{major} = %{version}-%{release}
Provides:     %{name}%{major}%{?_isa} = %{version}-%{release}
Obsoletes:    %{_lib}yui15 < 4.2.17

%description -n %libname
This package contains the library needed to run programs dynamically linked
with libyui.

%files -n %libname
%doc COPYING* README.md
%dir %{_libdir}/yui
%dir %{_datadir}/libyui
%{_libdir}/libyui.so.%{major}{,.*}


#----------------------------------------------------------
# libyui-devel

%package -n %develname
Summary:      libYUI, YaST2 User Interface Engine - header files
Group:        Development/C++
Requires:     %{libname} >= %{version}
Requires:     boost-devel
Provides:     %{name}-devel = %{version}-%{release}
Provides:     yui-devel = %{version}-%{release}

%description -n %develname
This is the development package for libyui user interface engine that provides
the abstraction from graphical user interfaces (Qt, Gtk) and text based user
interfaces (ncurses).

%files -n %develname
%{_libdir}/libyui.so
%{_libdir}/pkgconfig/libyui.pc
%{_includedir}/yui/*.h
%{_datadir}/libyui/buildtools

#-----------------------------------------------------------------------
# libyui-qt

%package -n %libqt
Summary:        Libyui - Qt (graphical) user interface
Group:          System/Libraries
Requires:       %{_lib}qt5x11extras5
Provides:       %{yui_qt_name} = %{version}-%{release}
Provides:       %{yui_qt_name}%{?_isa} = %{version}-%{release}
Provides:       %{yui_qt_name}%{major} = %{version}-%{release}
Provides:       %{yui_qt_name}%{major}%{?_isa} = %{version}-%{release}
Obsoletes:      %{_lib}yui15-qt < 4.2.17

%description -n %libqt
This package contains the Qt (graphical) user interface component for libyui.

%files -n %libqt
%doc COPYING*
%{_libdir}/yui/libyui-qt.so.%{major}{,.*}

#-----------------------------------------------------------------------
# libyui-qt-devel

%package -n %devqt
Summary:        Libyui - Qt (graphical) user interface header files
Group:          Development/KDE and Qt
Requires:       libyui-devel
Requires:       %{yui_qt_name} = %{version}-%{release}
Provides:       yui-qt-devel = %{version}-%{release}

%description -n %devqt
This package contains the header files for the Qt based user interface
component for libyui.

This package is not needed to develop libyui-based applications, only to
develop extensions for libyui-qt.

%files -n %devqt
%{_includedir}/yui/qt
%{_libdir}/yui/libyui-qt*.so
%{_libdir}/pkgconfig/libyui-qt.pc


#-----------------------------------------------------------------------
# libyui-ncurses

%package -n %libncurses
Summary:        Libyui - NCurses (text based) user interface
Group:          System/Libraries
Provides:       %{yui_ncurses_name} = %{version}-%{release}
Provides:       %{yui_ncurses_name}%{?_isa} = %{version}-%{release}
Provides:       %{yui_ncurses_name}%{major} = %{version}-%{release}
Provides:       %{yui_ncurses_name}%{major}%{?_isa} = %{version}-%{release}
Obsoletes:      %{_lib}yui15-ncurses < 4.2.17

%description -n %libncurses
This package contains the NCurses (text based) user interface component for
libyui.

%files -n %libncurses
%doc COPYING*
%{_libdir}/yui/libyui-ncurses.so.%{major}{,.*}

#-----------------------------------------------------------------------
# libyui-ncurses-devel

%package -n %devncurses
Summary:        Libyui - Header files for the NCurses (text based) user interface
Group:          Development/Other
Requires:       libyui-devel
Requires:       %{yui_ncurses_name} = %{version}-%{release}
Provides:       yui-ncurses-devel = %{version}-%{release}

%description -n %devncurses
This package contains the header files for the NCurses (text based) user
interface component for libyui.

This package is not needed to develop libyui-based applications, only to
develop extensions for libyui-ncurses.

%files -n %devncurses
%{_libdir}/yui/libyui-ncurses*.so
%{_includedir}/yui/ncurses
%{_libdir}/pkgconfig/libyui-ncurses.pc


#----------------------------------------------------------
# libyui-ncurses-tools

%package -n %{yui_ncurses_name}-tools

Summary:        Libyui - tools for the NCurses (text based) user interface
Group:          System/Libraries
Requires:       screen

%description -n %{yui_ncurses_name}-tools
This package contains tools for the NCurses (text based) user interface
component for libyui:

libyui-terminal - useful for testing on headless machines

%files -n %{yui_ncurses_name}-tools
%{_bindir}/libyui-terminal

#----------------------------------------------------------
# ruby-yui

%package -n ruby-yui
License:        GPLv2+
Summary:        Ruby bindings for libyui
Group:          Development/Ruby

%description -n ruby-yui
This package provides Ruby language bindings to access functions of libyui, the
YaST User Interface engine that provides the abstraction from graphical user
interfaces (Qt, Gtk) and text based user interfaces (ncurses).

%files -n ruby-yui
%doc libyui-bindings/swig/ruby/examples/*.rb
%{ruby_vendorarchdir}/_yui.so

#----------------------------------------------------------
# python3-yui

%package -n python3-yui
License:        GPLv2+
Summary:        Python 3 bindings for libyui
Group:          Development/Python
%{?python_provide:%python_provide python3-yui}

%description -n python3-yui
This package provides Python 3 language bindings to access functions of libyui,
the YaST User Interface engine that provides the abstraction from graphical
user interfaces (Qt, Gtk) and text based user interfaces (ncurses).

%files -n python3-yui
%doc libyui-bindings/swig/python/examples/*.py
%{python3_sitearch}/_yui.so
%{python3_sitearch}/yui.*
%{python3_sitearch}/__pycache__/*

#----------------------------------------------------------
# perl-yui

%package -n perl-yui
License:        GPLv2+
Summary:        Perl bindings for libyui
Group:          Development/Perl

%description -n perl-yui
This package provides Perl language bindings to access functions of libyui, the
YaST User Interface engine that provides the abstraction from graphical user
interfaces (Qt, Gtk) and text based user interfaces (ncurses).

%files -n perl-yui
%doc libyui-bindings/swig/perl/examples/*.pl
%{perl_vendorarch}/yui.so
%{perl_vendorlib}/yui.pm

#----------------------------------------------------------

%prep
%autosetup -p1 -n %{name}-%{version}

%build
# Let's pass cmake definitions to all the project to simplify building in a loop
for pkgname in libyui libyui-qt libyui-ncurses libyui-bindings ;do
  pushd $pkgname

  %cmake \
      -DBUILD_EXAMPLES=OFF \
      -DWITH_MGA=%{?with_mga:ON}%{!?with_mga:OFF} \
      -DWITH_MONO=OFF \
      -DPYTHON_EXECUTABLE=%{python3} \
      -DPYTHON_INCLUDE_DIR=%{_includedir}/python%{python3_version} \
      -DPYTHON_SITEDIR=%{python3_sitearch} \
      -DPYTHON_LIB_DIR=%{python3_sitelib} \
      -DWERROR=off

  %cmake_build

  popd
done

%install

for pkgname in libyui libyui-qt libyui-ncurses libyui-bindings ;do
  pushd $pkgname
  %cmake_install
  popd
done

install -m0755 -d %{buildroot}%{_libdir}/yui


%changelog
* Sun Jul 27 2025 daviddavid <daviddavid> 4.4.4-11.mga10
+ Revision: 2260804
- fix build with cmake 4.0
+ umeabot <umeabot>
- Mageia 10 Mass Rebuild

* Tue Mar 04 2025 wally <wally> 4.4.4-10.mga10
+ Revision: 2160363
- rebuild for python3.13

* Mon Mar 03 2025 wally <wally> 4.4.4-9.mga10
+ Revision: 2159971
- rebuild for python3.13

* Sat Feb 01 2025 pterjan <pterjan> 4.4.4-8.mga10
+ Revision: 2144279
- Rebuild for Ruby 3.4

* Wed Dec 04 2024 pterjan <pterjan> 4.4.4-7.mga10
+ Revision: 2120957
- Rebuild for Ruby 3.3

* Fri Aug 23 2024 tv <tv> 4.4.4-6.mga10
+ Revision: 2089684
- Rebuild for perl-5.40

* Thu Dec 28 2023 daviddavid <daviddavid> 4.4.4-5.mga10
+ Revision: 2022767
- rebuild for py3.12

* Tue Dec 05 2023 daviddavid <daviddavid> 4.4.4-4.mga10
+ Revision: 2013191
- rebuild for new perl 5.38.0

* Tue Feb 28 2023 wally <wally> 4.4.4-3.mga9
+ Revision: 1945724
- add more provides to lib pkgs

* Sun Oct 09 2022 papoteur <papoteur> 4.4.4-2.mga9
+ Revision: 1895671
- Rebuild for python3-yui requiring libyui-mga16

* Sat Oct 08 2022 anaselli <anaselli> 4.4.4-1.mga9
+ Revision: 1895508
- rebuilt new libyui 4.4.4 with mga

* Sat Oct 08 2022 anaselli <anaselli> 4.4.4-0.1.mga9
+ Revision: 1895495
- Release 4.4.4

* Tue Jun 07 2022 umeabot <umeabot> 4.2.16-4.mga9
+ Revision: 1862627
- Rebuild for Perl 5.36
+ papoteur <papoteur>
- Suppress the flag Werror for the build, for GCC 12

* Fri Feb 25 2022 pterjan <pterjan> 4.2.16-3.mga9
+ Revision: 1784569
- Rebuild for Ruby 3.1

* Mon Feb 14 2022 tv <tv> 4.2.16-2.mga9
+ Revision: 1774501
- Rebuild for python-3.10

* Sun Oct 03 2021 wally <wally> 4.2.16-1.mga9
+ Revision: 1748952
- new version 4.2.16

* Sun Sep 12 2021 wally <wally> 4.2.15-2.mga9
+ Revision: 1745324
- build bindings with libyui-mga

* Sun Sep 12 2021 wally <wally> 4.2.15-1.mga9
+ Revision: 1745318
- new version 4.2.15
- build libyui-mga again separately to avoid %%mkrel issues when only another version changes
- add bcond for building bindings with/without libyui-mga
- fix lib pkg names
- clean .spec

* Thu Sep 09 2021 wally <wally> 4.2.14-2.mga9
+ Revision: 1744701
- rebuild for boost 1.77.0
+ anaselli <anaselli>
- new 4.2.14 with libyui-mga 1.2.1

* Sat Jan 09 2021 wally <wally> 3.10.0-3.mga8
+ Revision: 1669978
- rebuild with doxygen 1.9.1

* Thu Aug 20 2020 joequant <joequant> 3.10.0-2.mga8
+ Revision: 1616813
- fix cmake build

* Mon Jun 29 2020 anaselli <anaselli> 3.10.0-1.mga8
+ Revision: 1600421
- new 3.10.0

* Tue Apr 21 2020 anaselli <anaselli> 3.9.3-2.mga8
+ Revision: 1570466
- Fixing YTable crash in bindings

* Fri Mar 27 2020 anaselli <anaselli> 3.9.3-1.mga8
+ Revision: 1561120
- new version 3.9.3

* Fri Feb 14 2020 umeabot <umeabot> 3.4.2-2.mga8
+ Revision: 1521223
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros

* Sun Dec 16 2018 anaselli <anaselli> 3.4.2-1.mga7
+ Revision: 1341782
- new version 3.4.2

* Mon Oct 08 2018 daviddavid <daviddavid> 3.3.3-3.mga7
+ Revision: 1318715
- use our cmake compile flags
- add a Source URL

* Mon Oct 08 2018 daviddavid <daviddavid> 3.3.3-2.mga7
+ Revision: 1318710
- add patch to fix build with gcc8
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild

* Sun Jan 28 2018 anaselli <anaselli> 3.3.3-1.mga7
+ Revision: 1197751
- version 3.3.3

* Sun Oct 09 2016 anaselli <anaselli> 3.2.7-1.mga6
+ Revision: 1059749
- new 2.3.7 as upstream
  Patch to avoid crash with externale widget plugins
  Patch to allow first item selection

* Fri Feb 12 2016 umeabot <umeabot> 3.2.3-0.git20151013.2.mga6
+ Revision: 956015
- Mageia 6 Mass Rebuild

* Tue Oct 13 2015 anaselli <anaselli> 3.2.3-0.git20151013.1.mga6
+ Revision: 890451
- new version 3.2.3 merged

* Wed Oct 15 2014 umeabot <umeabot> 3.1.4-0.git20140826.3.mga5
+ Revision: 741904
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.1.4-0.git20140826.2.mga5
+ Revision: 681910
- Mageia 5 Mass Rebuild

* Tue Aug 26 2014 anaselli <anaselli> 3.1.4-0.git20140826.1.mga5
+ Revision: 668479
- Fixed YLog building issue
- fixed source package
- updated to upstream master

* Fri Apr 18 2014 anaselli <anaselli> 3.1.3-0.git20140418.1.mga5
+ Revision: 616868
- Updated to 3.1.3 from anaselli branch

* Mon Apr 07 2014 anaselli <anaselli> 3.0.14-0.git20140407.1.mga5
+ Revision: 612761
- Fixed a crash if loading yui-mga first

* Sun Mar 30 2014 anaselli <anaselli> 3.0.13-0.git20140316.2.mga5
+ Revision: 610485
- Added debug symbols

* Sat Mar 29 2014 anaselli <anaselli> 3.0.13-0.git20140316.1.mga5
+ Revision: 609604
- new version 3.0.13

* Wed Nov 27 2013 anaselli <anaselli> 3.0.10-0.git20131124.1.mga4
+ Revision: 553785
- missed texlive-texmf dependency
- updated to upstream/master and anaselli branch for mageia plugin management
+ umeabot <umeabot>
- Mageia 4 Mass Rebuild

* Tue Jul 09 2013 fwang <fwang> 3.0.8-3.mga4
+ Revision: 451669
- rebuild for new boost

* Sun Jun 30 2013 anaselli <anaselli> 3.0.8-2.mga4
+ Revision: 448645
- License changed

* Sun Jun 30 2013 anaselli <anaselli> 3.0.8-1.mga4
+ Revision: 448633
- new version 3.0.8

* Thu Apr 11 2013 barjac <barjac> 2.42.4-0.git20130107.4.mga3
+ Revision: 409651
- rebuild for boost-1.53
- patched for boost-1.53 from upstream

* Sun Jan 20 2013 anaselli <anaselli> 2.42.4-0.git20130107.3.mga3
+ Revision: 389850
- Updated to master

* Sat Jan 12 2013 umeabot <umeabot> 2.42.4-0.git20130107.2.mga3
+ Revision: 358732
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Jan 07 2013 anaselli <anaselli> 2.42.4-0.git20130107.1.mga3
+ Revision: 341368
- New upstream version 2.42.4

* Sat Nov 10 2012 anaselli <anaselli> 2.42.3-0.git20121105.1.mga3
+ Revision: 316866
- new version 2.42.3 (aligned to yui master)

* Sat Nov 03 2012 anaselli <anaselli> 2.42.2-0.git20121102.1.mga3
+ Revision: 313332
- Updated from fork https://github.com/anaselli/libyui to add missed functionality

* Mon Oct 29 2012 anaselli <anaselli> 2.42.2-0.git20120908.2.mga3
+ Revision: 311523
- Fixed boost-devel dependency for devel package

* Sun Sep 16 2012 anaselli <anaselli> 2.42.2-0.git20120908.1.mga3
+ Revision: 294602
- ed git date to allow upgradability
- Added documentation
- updated to 2.42.2-0840dd8

* Sun Jul 22 2012 anaselli <anaselli> 2.42.0-0.git.e327da9.1.mga3
+ Revision: 273570
- New libyui from git 2.42.0
+ matteo <matteo>
- replaced %%_prefix/include with %%_includedir macro

* Sun Jun 17 2012 matteo <matteo> 2.21.1-2.mga3
+ Revision: 261175
- added missing major
- obsoletes previous release
- reviewed spec file (package names corrected)

* Sun Jun 17 2012 matteo <matteo> 2.21.1-1.mga3
+ Revision: 261156
- spec file reviewed (cleaned some rpmlint warnings)
- imported package libyui

